#include "Point.h"
#include "Sprite.h"
#include "Main.h"
#include "Chars.h"

constexpr byte MaxCount = SpriteCount - Sprite_Point;
// const byte Color = 14;
constexpr byte Time = 6;
static const word[] Values = { 10, 20, 40, 80 };

Point[MaxCount] Points;


void InitPoints()
{
    ptr<Point> pPoint;
    byte sprite;
    sprite = Sprite_Point;
    for (pPoint: Points) {
        pPoint->time = 0;
        pPoint->sprite = sprite;
        HideSprite(sprite);
        ++sprite;
    }
}


void StartPoint(byte x, byte y, byte rate)
{
    ptr<Point> pPoint;
    AddScore(Values[rate]);
    for (pPoint: Points) {
        if (pPoint->time != 0) continue;
        pPoint->x = x;
        pPoint->y = y;
        pPoint->time = Time;
        ShowSprite((ptr<Movable>)pPoint, Char_Point + (rate << 2));
        return;
    }
}


void UpdatePoints()
{
    ptr<Point> pPoint;
    for (pPoint: Points) {
        if (pPoint->time == 0) continue;
        --pPoint->time;
        if (pPoint->time == 0) {
            HideSprite(pPoint->sprite);
        }
    }
}
