#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Stage.h"

constexpr byte InvalidCode = 0xff;
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->code = InvalidCode;
        p->oldCode = InvalidCode;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    p = Sprites + pMovable->sprite;
    if (p->oldCode != InvalidCode) {
        SetRowFlags(p->oldY >> 1, 3);
    }
    p->x = pMovable->x;
    p->y = pMovable->y;
    p->code = code;
    SetRowFlags(p->y >> 1, 3);
    // p->oldX = p->x;
    p->oldY = p->y;
    p->oldCode = p->code;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    SetRowFlags(p->y >> 1, 3);
    p->code = InvalidCode;
    p->oldCode = p->code;
}


// void EraseSprites() 
// {
//     ptr<Sprite> p;
//     for (p : Sprites) {
//         if (p->oldCode != InvalidCode && (
//             p->oldX != p->x || 
//             p->oldY != p->y ||
//             p->code == InvalidCode
//         )) {
//             ptr<byte> pVVram;
//             byte y;
//             y = p->oldY;
//             pVVram = VramPtr(p->oldX, y);
//             pFront[0] = pBack[0];
//             pFront[1] = pBack[1];
//             pFront[VramWidth] = pBack[VramWidth];
//             pFront[VramWidth + 1] = pBack[VramWidth + 1];
//             SetRowFlags(y, 3);
//         }
//     }
// }

void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->code != InvalidCode) {
            // bool changed;
            ptr<byte> pVVram;
            byte y, c;
            // changed = p->oldX != p->x || p->oldY != p->y || p->oldCode != p->code;
            y = p->y;
            pVVram = VVramPtr(p->x, y);
            c = p->code;
            pVVram[0] = c; 
            ++c; pVVram[1] = c;
            ++c; pVVram[VVramWidth] = c;
            ++c; pVVram[VVramWidth + 1] = c;
            // if (changed) {
                // SetRowFlags(y >> 1, 3);
                // if (p->oldCode != InvalidCode) {
                //     SetRowFlags(p->oldY >> 1, 7);
                // }
            // }
        }
        // p->oldX = p->x;
        // p->oldY = p->y;
        // p->oldCode = p->code;
    }
}
