include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext CellMap_, VVram_, RowFlags_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

pMap equ ZW0
pVVram equ ZW1

mapOffset equ ZB1
cell equ ZB2
yCount equ ZB3
rowFlag equ ZB4
flagOffset equ ZB5
maskBit equ ZB6


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public	VVramPtr_@Param0
VVramPtr_.x_:	defs 1
VVramPtr_@Param1: public	VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	pha
        lda	VVramPtr_.y_
        asl a | asl a | asl a  ;*8
        sta <pVVram | lda #0 | sta <pVVram+1
        asl <pVVram | rol <pVVram+1 ;16
        asl <pVVram | rol <pVVram+1 ;32
        lda VVramPtr_.x_ | clc | adc <pVVram | sta <pVVram
        lda <pVVram+1 | adc #0 | sta <pVVram+1
        lda <pVVram | clc|adc #low VVram_ | tay
        lda <pVVram+1 | adc #high VVram_ | tax
	pla
rts


; void Put4C(byte x, byte y, byte c);
dseg
Put4C_@Param0: public Put4C_@Param0
    defb 0
Put4C_@Param1: public Put4C_@Param1
    defb 0
Put4C_@Param2: public Put4C_@Param2
    defb 0
cseg
Put4C_: public Put4C_
    pha
        lda Put4C_@Param0 | sta VVramPtr_@Param0
        lda Put4C_@Param1 | sta VVramPtr_@Param1
        jsr VVramPtr_
        sty <pVVram | stx <pVVram+1
        ldx Put4C_@Param2
        lda #2 | sta <yCount
        do
            ldy #0
            do
                txa
                sta (<pVVram),y
                iny
                inx
                cpy #2
            while ne | wend
            lda <pVVram | clc|adc #VVramWidth | sta <pVVram
            lda <pVVram+1 | adc #0 | sta <pVVram+1
            dec <yCount
        while ne | wend
    pla
rts


; ptr<byte> CellMapPtr(byte x, byte y);
dseg
CellMapPtr_@Param0: public	CellMapPtr_@Param0
CellMapPtr_.x_:	defs 1
CellMapPtr_@Param1: public	CellMapPtr_@Param1
CellMapPtr_.y_:	defs 1
cseg
CellMapPtr_: public	CellMapPtr_
	pha
        lda	CellMapPtr_.y_
        asl a | asl a | asl a | asl a ;*16
        clc|adc CellMapPtr_.x_
        clc|adc #low CellMap_ | tay
        lda #0 | adc #high CellMap_ | tax
	pla
rts


cseg
wallCodes:
    defb Char_Space, Char_Space, Char_Space, Char_Space 
    defb Char_Wall_Left, Char_Space, Char_Wall_Left, Char_Space 
    defb Char_Space, Char_Wall_Right, Char_Space, Char_Wall_Right
    defb Char_Wall_Left, Char_Wall_Right, Char_Wall_Left, Char_Wall_Right
    defb Char_Wall_Top, Char_Wall_Top, Char_Space, Char_Space
    defb Char_Wall_LeftTop, Char_Wall_Top, Char_Wall_Left, Char_Space
    defb Char_Wall_Top, Char_Wall_RightTop, Char_Space, Char_Wall_Right
    defb Char_Wall_LeftTop, Char_Wall_RightTop, Char_Wall_Left, Char_Wall_Right
    defb Char_Space, Char_Space, Char_Wall_Bottom, Char_Wall_Bottom
    defb Char_Wall_Left, Char_Space, Char_Wall_LeftBottom, Char_Wall_Bottom
    defb Char_Space, Char_Wall_Right, Char_Wall_Bottom, Char_Wall_RightBottom
    defb Char_Wall_Left, Char_Wall_Right, Char_Wall_LeftBottom, Char_Wall_RightBottom
    defb Char_Wall_Top, Char_Wall_Top, Char_Wall_Bottom, Char_Wall_Bottom
    defb Char_Wall_LeftTop, Char_Wall_Top, Char_Wall_LeftBottom, Char_Wall_Bottom
    defb Char_Wall_Top, Char_Wall_RightTop, Char_Wall_Bottom, Char_Wall_RightBottom
    defb Char_Wall_LeftTop, Char_Wall_RightTop, Char_Wall_LeftBottom, Char_Wall_RightBottom
    ; 16; Rock
    defb Char_Rock, Char_Rock+1, Char_Rock+2, Char_Rock+3
    ; 17; Soil
    defb Char_Soil, Char_Soil+1, Char_Soil+1, Char_Soil
    ; 18; Bedrock
    defb Char_Bedrock, Char_Bedrock, Char_Bedrock, Char_Bedrock

cseg
DrawCell:
    lda wallCodes,x | inx
    sta (pVVram),y | iny
    lda wallCodes,x | inx
    sta (pVVram),y
    tya | clc|adc #VVramWidth-1 | tay
    lda wallCodes,x | inx
    sta (pVVram),y | iny
    lda wallCodes,x | inx
    sta (pVVram),y
    tya | clc|adc #-VVramWidth+1 | tay
rts

InitRow:
    lda #low VVram_ | sta <pVVram
    lda #high VVram_ | sta <pVVram+1
    lda #0 | sta <mapOffset
    lda #MapHeight | sta <yCount
rts

NextRow:
    lda <pVVram | clc|adc #VVramWidth*2 | sta <pVVram
    lda <pVVram+1 | adc #0 | sta <pVVram+1
    dec <yCount
rts

CellMapToVVramRow: public CellMapToVVramRow
    ldy #0
    do
        ldx <mapOffset
        lda CellMap_,x | sta <cell
        inx | stx <mapOffset
        and #$0f
        if eq
            lda <cell
            and #$f0
            lsr a | lsr a
            tax
            jsr DrawCell
            jmp CellMapToVVramRow_next
        endif
        lda <cell
        and #$04
        if ne
            ldx #16*4; Rock
            jsr DrawCell
            jmp CellMapToVVramRow_next
        endif
        lda <cell
        and #$0f
        cmp #1
        if eq
            ldx #17*4; Soil
            jsr DrawCell
            jmp CellMapToVVramRow_next
        endif
        cmp #2
        if eq
            ldx #18*4; Bedrock
            jsr DrawCell
            jmp CellMapToVVramRow_next
        endif
        CellMapToVVramRow_next:
        cpy #VVramWidth
    while ne | wend
rts

ClearRowFlags:
    ldx #0
    lda #0
    do
        sta RowFlags_,x
        inx
        cpx #3
    while ne | wend
rts


; void CellMapToVVramAll();
cseg
CellMapToVVramAll_: public CellMapToVVramAll_
    pha
        jsr InitRow
        do
            jsr CellMapToVVramRow
            jsr NextRow
        while ne | wend
        jsr ClearRowFlags
    pla
rts


; void CellMapToVVramChanged();
cseg
CellMapToVVramChanged_: public CellMapToVVramChanged_
    pha
        ldx #0
        lda RowFlags_,x | sta <rowFlag
        inx | stx <flagOffset
        lda #1 | sta <maskBit
        jsr InitRow
        do
            lda <rowFlag
            and <maskBit
            if ne
                jsr CellMapToVVramRow
            else
                lda <mapOffset | clc|adc #MapWidth | sta <mapOffset
            endif
            asl <maskBit
            if eq
                ldx <flagOffset
                lda RowFlags_,x | sta <rowFlag
                inx | stx <flagOffset
                lda #1 | sta <maskBit
            endif
            jsr NextRow
        while ne | wend
        jsr ClearRowFlags
    pla
rts


; void SetRowFlags(byte y, byte b);
dseg
SetRowFlags_@Param0: public SetRowFlags_@Param0
    defb 0
SetRowFlags_@Param1: public SetRowFlags_@Param1
    defb 0
SetRowFlags_low equ ZB0
SetRowFlags_high equ ZB1
cseg
SetRowFlags_: public SetRowFlags_
    pha
        lda SetRowFlags_@Param1 | sta <SetRowFlags_low
        lda #0 | sta <SetRowFlags_high
       
        lda SetRowFlags_@Param0
        tay
        and #7
        tax
        do | while ne
            asl <SetRowFlags_low | rol <SetRowFlags_high
            dex
        wend
        
        tya
        lsr a | lsr a | lsr a
        tax
        
        lda RowFlags_,x
        ora <SetRowFlags_low
        sta RowFlags_,x
        inx
        lda RowFlags_,x
        ora <SetRowFlags_high
        sta RowFlags_,x
    pla
rts
